;  
	#include <p12f629.inc>

 __config _PWRTE_ON  &_MCLRE_OFF &_WDT_ON &_INTRC_OSC_NOCLKOUT &_CP_ON &_CPD_OFF &_BODEN_OFF

		org 0
	goto	start

; --------------------------- 
timer_delay	equ  20
timer_sound_L	equ  21
timer_sound_H	equ  22

; --------------------------- 
; GPIO
d_tris		equ  b'001000'
SOUND_1	equ  0
SOUND_2	equ  1
INPUT		equ  3
LED		equ	5

d_gpio_init	equ  b'000000'
d_sound_1	equ  b'000001'
d_sound_2	equ  b'000010'

d_option	equ  b'00001111'	; WDT c  2.3 
time_sound	equ  .3		;  / (x 62 mc)

; ---------------------------
w		equ  0
f		equ  1

; _____________________________________
; _____________________________________
;      
delay_1	goto	$+1
		clrwdt
delay_2	movlw	.37; .37-121  ; .78 ;.92
		movwf	timer_delay
ckl_delay	decfsz	timer_delay,f
		goto	ckl_delay
		return

; -------------------------------------
sound	movlw	time_sound
		movwf	timer_sound_H
		clrf	timer_sound_L
		
;  4.1  -> T/2 = 122 
ckl_sound	movlw	d_sound_1
		movwf	GPIO
		call	delay_1
		
		movlw	d_sound_2
		movwf	GPIO
		call	delay_2
		
		decfsz	timer_sound_L,f
		goto	ckl_sound
		
		decfsz	timer_sound_H,f
		goto	ckl_sound

		clrf	GPIO
		return
		
pause	movlw	time_sound
		movwf	timer_sound_H
		clrf	timer_sound_L
		
ckl_pause	nop ;movlw	d_sound_1
		nop		;movwf	GPIO
		call	delay_1
		
		nop		;movlw	d_sound_2
		nop		;movwf	GPIO
		call	delay_2
		
		decfsz	timer_sound_L,f
		goto	ckl_pause
		
		decfsz	timer_sound_H,f
		goto	ckl_pause

		clrf	GPIO
		return

; _____________________________________
;     
init		clrf	INTCON	;   
		movlw d_option	; 00001111-      1:128
		option			;  
		movlw	7		; 00000111
		movwf	CMCON	;   111 ()
		movlw	d_tris	; 00001000
		tris	GPIO	; GP0,GP1,GP2,GP4,GP5 -   , GP3-
		movlw	d_gpio_init ; 0
		movwf	GPIO	;     
		
	bsf	STATUS,RP0 		;  
		call	0x3FF 	;    
		movwf	OSCCAL	;     
		clrf	PIE1	;   :   EEPROM, ,   TMR1
		clrf	WPU		;   
		clrf	IOC		;        GP0-GP5
	bcf	STATUS,RP0
		
		return



; =============================================== 
start		call	init	;

; _____________________________________ 2.3 cek
main_ckl	clrwdt		;   
		sleep			;      
		nop				;          

test_ckl:		
		btfsc	GPIO,INPUT	;   
		goto 	main_ckl 	;   ,   
		call	sound		;   -  
		bsf		GPIO, LED	;  LED
		call	pause		; 
		bcf		GPIO, LED	;  LED
		goto	test_ckl	;             
	end
